<?php

namespace EnumType;

/**
 * This class stands for TypeDemarche EnumType
 * @subpackage Enumerations
 */
class TypeDemarche
{
    /**
     * Constant for value 'DIVN'
     * @return string 'DIVN'
     */
    const VALUE_DIVN = 'DIVN';
    /**
     * Constant for value 'DIVLN'
     * @return string 'DIVLN'
     */
    const VALUE_DIVLN = 'DIVLN';
    /**
     * Constant for value 'VNWW'
     * @return string 'VNWW'
     */
    const VALUE_VNWW = 'VNWW';
    /**
     * Constant for value 'VOWW'
     * @return string 'VOWW'
     */
    const VALUE_VOWW = 'VOWW';
    /**
     * Constant for value 'PIVO'
     * @return string 'PIVO'
     */
    const VALUE_PIVO = 'PIVO';
    /**
     * Constant for value 'PIVOL'
     * @return string 'PIVOL'
     */
    const VALUE_PIVOL = 'PIVOL';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_DIVN
     * @uses self::VALUE_DIVLN
     * @uses self::VALUE_VNWW
     * @uses self::VALUE_VOWW
     * @uses self::VALUE_PIVO
     * @uses self::VALUE_PIVOL
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DIVN,
            self::VALUE_DIVLN,
            self::VALUE_VNWW,
            self::VALUE_VOWW,
            self::VALUE_PIVO,
            self::VALUE_PIVOL,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
